# $Revision: 1.93 $, $Date: 2011/08/31 06:59:47 $
# TODO:
# - consider moving kvm groupadd/remove from -udev and kernel package to main package (why?)
# - kernel part - doesn't build now, but should we care in the HEAD?
#   btw. with kernel bcond we require >= 3:2.6.28 kernels which
#   could have the kvm stuff on its own
# NOTE:
# - as of 86 the source structure have changed comparing to 75 or 81
#   it looks like kvm is going to be merged with qemu, so in this
#   release the kvm is a subdirectory of the main qemu stuff
# - for 2.6.28.10+ kernels one could build the recent qemu (0.10.5)
#   with a KVM support - the presence of the support depends on the
#   contents of the <linux/kvm.h> header files checked by configure
#   at buildtime.
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_with	kernel		# build for unpatched kernel (which doesn't provide kvm.ko already)
%bcond_without	userspace	# don't build userspace utilities
%bcond_with	verbose		# verbose kernel module build
%bcond_with	internal_qemu	# use internal qemu
%bcond_with	alt_kernel_userspace # allow building userspace with alt_kernel set
#
%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if %{without alt_kernel_userspace}
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif
%endif
%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	2
%define		pname	kvm
Summary:	Kernel-based Virtual Machine for Linux
Summary(pl.UTF-8):	Oparta na jądrze maszyna wirtualna dla Linuksa
Name:		%{pname}%{_alt_kernel}
# http://www.linux-kvm.org/page/Choose_the_right_kvm_%26_kernel_version
Version:	88
Release:	%{rel}
License:	GPL v2
Group:		Applications/System
Source0:	http://dl.sourceforge.net/kvm/%{pname}-%{version}.tar.gz
# Source0-md5:	02371948fcee1fa2a77e7a457384d71c
Patch0:		%{pname}-fixes.patch
Patch1:		%{pname}-kernel-release.patch
Patch2:		%{pname}-ncurses.patch
URL:		http://www.linux-kvm.org/
BuildRequires:	bash
BuildRequires:	kernel%{_alt_kernel}-headers >= 3:2.6.28
BuildRequires:	sed >= 4.0
%if %{with kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.28
BuildRequires:	rpmbuild(macros) >= 1.379
%endif
%if %{with userspace}
BuildRequires:	SDL-devel
BuildRequires:	alsa-lib-devel
BuildRequires:	bluez-libs-devel
BuildRequires:	curl-devel
BuildRequires:	ncurses-devel
BuildRequires:	pciutils-devel
BuildRequires:	perl-Encode
BuildRequires:	perl-tools-pod
BuildRequires:	pkgconfig
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.202
BuildRequires:	tetex
BuildRequires:	texi2html
BuildRequires:	which
BuildRequires:	zlib-devel
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Provides:	group(kvm)
%if %{with internal_qemu}
Conflicts:	qemu
%else
Requires:	qemu
%endif
%endif
# noone to test ppc
ExclusiveArch:	%{ix86} %{x8664} ia64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# some SPARC (and PPC) boot image in ELF format
%define         _noautostrip .*%{_datadir}/qemu/openbios-.*

%ifarch %{ix86}
%define carch i386
%define karch x86
%define qemuarch x86_64
%endif
%ifarch %{x8664}
%define carch x86_64
%define karch x86
%define qemuarch x86_64
%endif
%ifarch ia64
%define carch ia64
%define karch ia64
%define qemuarch ia64
%endif
%ifarch ppc
%define carch powerpc
%define karch powerpc
%define qemuarch ppcemb
%endif

%description
KVM (for Kernel-based Virtual Machine) is a full virtualization
solution for Linux on x86 hardware. It consists of a loadable kernel
module (kvm.ko) and a userspace component.

Using KVM, one can run multiple virtual machines running unmodified
Linux or Windows images. Each virtual machine has private virtualized
hardware: a network card, disk, graphics adapter, etc.

%description -l pl.UTF-8
KVM (Kernel-based Virtual Machine) to pełne rozwiązanie wirtualizacji
dla Linuksa na sprzęcie x86. Zawiera ładowalny moduł jądra (kvm.ko)
oraz komponent działający w przestrzeni użytkownika.

Przy użyciu KVM można uruchomić wiele maszyn wirtualnych z
działającymi niezmodyfikowanymi obrazami Linuksa i Windows. Kazda z
maszyn wirtualnych ma prywatny wirtualizowany sprzęt: kartę sieciową,
dysk, kartę graficzną itp.

%package udev
Summary:	kvm udev scripts
Summary(pl.UTF-8):	Skrypty udev dla kvm
Group:		Applications/System
Requires:	group(kvm)

%description udev
kvm udev scripts.

%description udev -l pl.UTF-8
Skrypty udev dla kvm.

%package -n kernel%{_alt_kernel}-misc-kvm
Summary:	kvm - Linux kernel module
Summary(pl.UTF-8):	kvm - moduł jądra Linuksa
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel}
Requires(post,postun):	/sbin/depmod
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	module-init-tools >= 3.2.2-2

%description -n kernel%{_alt_kernel}-misc-kvm
kvm - Linux kernel module.

%description -n kernel%{_alt_kernel}-misc-kvm -l pl.UTF-8
kvm - moduł jądra Linuksa.

%prep
%setup -q -n %{pname}-%{version}
#patch0 -p1
%patch1 -p1
%patch2 -p1

sed -i 's#header-sync-$(if $(WANT_MODULE),n,y)#header-sync-n#g' Makefile
sed -i 's#^depmod_version=$#depmod_version=%{_kernel_ver}#' configure

%build
%if %{without kernel}
# qemu/configure uses linux/kvm.h to detect available features (KVM_CAP_* defs).
rm -r kvm/kernel/include/*
ln -s %{_kernelsrcdir}/include/linux kvm/kernel/include
ln -s %{_kernelsrcdir}/arch/%{karch}/include/asm kvm/kernel/include
%endif

# we build kernel modules with build_kernel_modules macro
mv -f kvm/kernel/configure kvm/kernel/configure_kvm

# not ac stuff
./configure \
	%{!?with_userspace:--disable-sdl} \
	%{!?with_userspace:--disable-gfx-check} \
	--audio-drv-list=oss,alsa \
	--cc="%{__cc}" \
	--extra-cflags="%{rpmcflags} -I/usr/include/ncurses" \
	--extra-ldflags="%{rpmldflags}" \
	--enable-mixemu \
	--disable-werror \
	--prefix=%{_prefix}

%if %{with kernel}
cd kvm/kernel
./configure_kvm \
	--arch=%{carch} \
	--kerneldir=%{_kernelsrcdir}
cd ../..
%endif

echo "CFLAGS=%{rpmcflags}" >> kvm/user/config.mak

%if %{with userspace}
%{__make} \
	CC="%{__cc}"
%endif

%if %{with kernel}
%build_kernel_modules -C kvm/kernel -m kvm,kvm-amd,kvm-intel
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%if %{without internal_qemu}
# removing files which are provided by required qemu package
rm -rf $RPM_BUILD_ROOT%{_datadir}/qemu $RPM_BUILD_ROOT%{_mandir} $RPM_BUILD_ROOT%{_docdir}
rm -f $RPM_BUILD_ROOT%{_bindir}/qemu-img
rm -f $RPM_BUILD_ROOT%{_bindir}/qemu-nbd
rm -f $RPM_BUILD_ROOT%{_bindir}/qemu-io
%endif

# changing binary name to avoid conflict with qemu
mv -f $RPM_BUILD_ROOT%{_bindir}/qemu-system-%{qemuarch} $RPM_BUILD_ROOT%{_bindir}/%{pname}
install -p kvm/kvm_stat $RPM_BUILD_ROOT%{_bindir}
install -p -D kvm/scripts/65-kvm.rules $RPM_BUILD_ROOT/etc/udev/rules.d/kvm.rules
%endif

%if %{with kernel}
%install_kernel_modules -m kvm/kernel/{kvm-amd,kvm,kvm-intel} -d misc
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 160 kvm

%postun
if [ "$1" = "0" ]; then
	%groupremove kvm
fi

%post   -n kernel%{_alt_kernel}-misc-kvm
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-misc-kvm
%depmod %{_kernel_ver}

%if %{with userspace}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/kvm*
%if %{with internal_qemu}
%attr(755,root,root) %{_bindir}/qemu-nbd
%attr(755,root,root) %{_bindir}/qemu-img
%attr(755,root,root) %{_bindir}/qemu-io
%{_datadir}/qemu
%{_docdir}/qemu
%{_mandir}/man1/qemu.1*
%{_mandir}/man1/qemu-img.1*
%{_mandir}/man8/qemu-nbd.8*
%endif

%files udev
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/udev/rules.d/kvm.rules
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-misc-kvm
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/kvm*
%endif

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: kvm.spec,v $
Revision 1.93  2011/08/31 06:59:47  arekm
- release 2

Revision 1.92  2009/11/18 20:26:22  glen
- cleanup groupadd/remove kvm mess (where is supposed to be added/created??!)
  anyway, made it being created/removed where appropriate Provides group line was present

Revision 1.91  2009/11/18 20:22:53  glen
- -udev requires kvm group

Revision 1.90  2009/09/05 10:11:43  glen
- groupadd deps; adapter

Revision 1.89  2009/09/04 21:06:32  adamg
- group add/remove in udev package

Revision 1.88  2009/09/04 20:46:47  adamg
- BR: bluez-libs-devel, curl-devel, ncurses-devel, perl-Encode and pkgconfig
- fix ncurses detection (-ncurses.patch)
- pass cflags and ldflags

Revision 1.87  2009/09/04 20:08:03  adamg
- BR: pciutils-devel

Revision 1.86  2009/09/04 20:07:39  adamg
- sort BRs, pass cc

Revision 1.85  2009/07/15 06:41:36  mguevara
- up to 88-1

Revision 1.84  2009/06/26 21:27:10  mguevara
- up to 87-1

Revision 1.83  2009/06/20 22:32:08  adamg
- switch to linux-kvm.org

Revision 1.82  2009/06/20 20:04:02  mguevara
- up to 86-1; updated kvm-kernel-release.patch; moved qemu-nbd to the
  internal_qemu bcond to eliminate conflicts between kvm and qemu packages;
  userland builds and works fine (tested with kernel-2.6.28.9-3.x86_64);
  added some notes about source structure changes.

Revision 1.81  2009/03/16 22:59:22  glen
- qemu file-conflict

Revision 1.80  2009/02/25 22:46:58  pluto
- fix build with 2.6.28+ (new asm includes layout).

Revision 1.79  2008/12/29 11:10:36  blues
- security note CVE-2008-2382

Revision 1.78  2008/12/17 00:04:40  pluto
- fix pld-build.

Revision 1.77  2008/12/15 21:17:04  pluto
- updated to 81 [fixes: CVE-2008-2382]

Revision 1.76  2008/12/08 23:03:42  sparky
- added with alt_kernel_userspace bcond - allows building userspace with
  alt_kernel

Revision 1.75  2008/12/08 22:47:22  glen
- alt kernel safe

Revision 1.74  2008/12/08 22:46:51  glen
- removed unreasoned userspace bcond disabling (accidental?)

Revision 1.73  2008/12/08 19:25:33  sparky
- drop ppc: if there is anyone with hardware to test it please let me know

Revision 1.72  2008/12/08 15:57:02  sparky
- reenabled updated kvm patch, builds on ppc but is completely untested
  and may not work

Revision 1.71  2008/12/08 13:07:23  pluto
- fix dist-wide KVM_CAP_* detection.
- enable alsa backend.

Revision 1.70  2008/12/07 10:46:24  pluto
- updated to 80, parallel build disabled.

Revision 1.69  2008/11/20 01:22:08  pluto
- updated to 78 (79 doesn't build).

Revision 1.68  2008/10/12 19:47:00  paszczus
- updated to 77

Revision 1.67  2008/09/30 15:18:17  paszczus
- updated to 76

Revision 1.66  2008/09/21 15:57:02  sparky
- link whole kernel include tree, builds on x86_64

Revision 1.65  2008/09/21 13:31:35  sparky
- min kernel: 2.6.26, older kernels have incomplete kvm headers

Revision 1.64  2008/09/20 23:50:31  sparky
- fixes patch
- fix output binary name
- pass rpmcflags

Revision 1.63  2008/09/19 13:05:56  sparky
- configure and kernel arch are different

Revision 1.62  2008/09/19 12:35:55  sparky
- some ppc progress

Revision 1.61  2008/09/19 09:54:29  paszczus
- Error: Could not find libfdt on ppc

Revision 1.60  2008/09/19 09:45:00  paszczus
- try to build ppc (just test)

Revision 1.59  2008/09/19 09:39:11  paszczus
- updated URL

Revision 1.58  2008/09/19 09:35:33  pluto
- updated to 75.

Revision 1.57  2008/09/07 20:04:11  charles
- BR: rpm-pythonprov, tetex, which (if with userspace)
- updated/fixed %files

Revision 1.56  2008/09/05 17:12:26  pluto
- TODO += kvm group vs. udev rules.

Revision 1.55  2008/08/28 13:36:47  pluto
- updated to 74.

Revision 1.54  2008/08/17 17:40:22  qboosh
- BR: sed 4

Revision 1.53  2008/08/17 17:39:25  qboosh
- bcond descs

Revision 1.52  2008/08/11 10:36:52  kolodko
- corrected _noautostrip macro from last commit

Revision 1.51  2008/08/10 16:28:35  kolodko
- added _noautostrip  for openbios-sparc64, failed build on x86_64

Revision 1.50  2008/08/05 15:30:50  glen
- cosmetic

Revision 1.49  2008/08/05 11:10:54  arekm
- url with hints about versions

Revision 1.48  2008/08/05 10:42:16  arekm
- another try

Revision 1.47  2008/08/05 10:28:48  arekm
- sed bugfix

Revision 1.46  2008/08/05 10:26:02  arekm
- don't process kernel subdir

Revision 1.45  2008/08/05 10:23:36  arekm
- omg, rsync used in build process

Revision 1.44  2008/08/05 10:19:05  arekm
- up to 72; HEAD is for kvm from official th kernels

Revision 1.43  2008/07/28 08:41:58  beorn
- reverted

Revision 1.41  2008/07/08 21:41:32  blues
- don't require external qemu, doesn't make sense.

Revision 1.40  2008/06/24 11:26:41  arekm
- release 4

Revision 1.39  2008-05-23 23:14:26  glen
- fix building without userspace
- alt_kernel build fixes on builders

Revision 1.38  2008-03-17 19:24:37  arvenil
- downgrade to version 0.60 which builds
- version 0.63, which doesn't build, moved to DEVEL
- release 3

Revision 1.37  2008-03-14 18:04:49  patrys
- rel 3

Revision 1.36  2008-03-10 12:21:45  arekm
- release 2

Revision 1.35  2008-03-09 12:51:19  blues
- package kvm_stat script

Revision 1.34  2008-03-07 21:10:52  arvenil
- up to 63

Revision 1.33  2008-02-26 21:52:47  arvenil
- up to 0.62

Revision 1.32  2008-02-23 08:50:46  arvenil
- up to 61

Revision 1.31  2008-02-11 11:32:21  arekm
- rel 2

Revision 1.30  2008-01-25 23:10:10  arvenil
- up to 60

Revision 1.29  2008-01-24 13:14:47  arekm
- allocated group for kvm is 160

Revision 1.28  2008-01-22 22:54:09  glen
- rel 3 (2.6.16.59-2)

Revision 1.27  2008-01-22 22:42:11  glen
- remove no_install_post_strip, not explained why it's there, probably copy-paste from kernel.spec

Revision 1.26  2008-01-17 00:06:42  glen
- rel 2

Revision 1.25  2008-01-05 09:48:05  arvenil
- up to 59

Revision 1.24  2008-01-03 12:30:24  qboosh
- EA fix, typo, more todo

Revision 1.23  2007-12-31 20:18:11  arvenil
- ExcludeArch: ppc (added TODO)
- release 1

Revision 1.22  2007-12-31 16:00:10  arvenil
- License for kernel module is GPL v2

Revision 1.21  2007-12-30 22:28:34  arvenil
- up to 58

Revision 1.20  2007-12-30 22:25:49  arvenil
- added kvm group and udev rule

Revision 1.19  2007-12-30 22:23:29  arvenil
- better way to package kvm
- R: qemu

Revision 1.18  2007-12-15 10:39:10  arvenil
- reverted remove BR: alsa-lib-devel

Revision 1.17  2007-12-14 21:23:02  arvenil
- rm BR: alsa-lib-devel (already required by SDL-devel)
- --enable-alsa

Revision 1.16  2007-12-14 14:03:41  arvenil
- up to 56

Revision 1.15  2007-12-12 21:28:47  qboosh
- sorted BRs

Revision 1.14  2007-12-09 15:26:27  wiget
- BR: perl-tools-pod for pod2man

Revision 1.13  2007-12-09 14:41:16  wiget
- updated to 55

Revision 1.12  2007-11-27 13:11:00  shadzik
- kvm-54, not tested
- rel 0.1

Revision 1.11  2007-10-29 14:37:14  areq
- 49

Revision 1.10  2007/10/29 11:17:04  arvenil
- no man anymore
- %{_libdir}/kvm/lib => %{_libdir}/kvm/%{_lib}
- rel 0.2

Revision 1.9  2007/10/28 22:07:39  areq
- 48, now build on TH

Revision 1.8  2007/06/07 22:02:38  areq
- kvm-27, NFY

Revision 1.7  2007/02/12 22:09:10  glen
- tabs in preamble

Revision 1.6  2007/02/12 01:06:38  baggins
- converted to UTF-8

Revision 1.5  2007/02/05 15:36:28  qboosh
- fixme: userspace shouldn't reference _kernelsrcdir

Revision 1.4  2007/02/05 15:34:07  qboosh
- pl, cleanup

Revision 1.3  2007/02/02 13:28:39  mkierus
- up to 12

Revision 1.2  2007/01/11 11:48:07  arekm
- more

Revision 1.1  2007/01/10 19:06:55  arekm
- raw, need gcc3
